proc read_temp {} {
	if {![is_e4]} {
		puts "Incorrect device. Suits 57940 only"
		return
	}
	reg write 0x6b2050 0x40000
	reg write 0x6b2060 0x40000
	
	while {1} {
		if {[reg read 0x6B2070]} {
			break
		}
	}

	# Wait for register to be cleared - may take up to 500 usec 
	while {1} {
		if {[reg read 0x6B2070] == 0} {
			break
		}
	}
	
        set line [format "%7s  %-5s  %-15s %-15s" "Sensor#" "Group" "Instance_on_top" "Temperature (Celcius)"] 
        puts "$line"
	for { set i  0} {$i < 20} { incr i} {
		set temp_code [expr [reg read [expr 0x6B2400 + 0x10*$i]]]
		if {$temp_code == 0} {
			puts "ERROR: Temp code sensor $i is 0"
			return
		}
		set temperature [expr {[expr -4.84E+01*pow($temp_code, 0)] +
		 [expr 0.3102*pow($temp_code, 1)] +
		 [expr -0.00018201*pow($temp_code, 2)] +
		 [expr 8.1542E-08*pow($temp_code, 3)] +
		 [expr -1.6743E-11*pow($temp_code, 4)]} ]
		set sensor_array {
		                {AUX     NM              i_ecore.i_nm.i_nw_pd                    }
	         {AUX     NM              i_ecore.i_nm.i_nw_pd                    }
	         {MAIN    VMAIN1_PD       i_ecore.i_epath0_i_vmain1_pd.i_cfc_pd   }
	         {MAIN    VMAIN2_PD       i_ecore.i_epath0_i_vmain2_pd.i_pxp_pd   }
	         {AUX     HOST_PD         i_ecore.i_host_pd                       }
                {AUX     HOST_PD         i_ecore.i_host_pd                       }
                {MAIN    VMAIN2_PD       i_ecore.i_epath0_i_vmain2_pd.i_tmus_pd  }
                {MAIN    VMAIN2_PD       i_ecore.i_epath0_i_vmain2_pd.i_tmus_pd  }
                {MAIN    VMAIN2_PD       i_ecore.i_epath0_i_vmain2_pd.i_tmus_pd  }
       	 {AUX     NM              i_ecore.i_nm.i_nm_pd_e0                 }
      		 {AUX     NM              i_ecore.i_nm.i_nm_pd_e0                 }
                {AUX     NM              i_ecore.i_nm                            }
                {AUX     NM              i_ecore.i_nm                            }
                {MAIN    VMAIN2_PD       i_ecore.i_epath0_i_vmain2_pd            }
                {MAIN    VMAIN2_PD       i_ecore.i_epath0_i_vmain2_pd            }         
                {MAIN    VMAIN1_PD       i_ecore.i_epath0_i_vmain1_pd            }
                {MAIN    VMAIN1_PD       i_ecore.i_epath0_i_vmain1_pd            }
                {MAIN    VMAIN1_PD       i_ecore.i_epath0_i_vmain1_pd            }
                {MAIN    VMAIN1_PD       i_ecore.i_epath0_i_vmain1_pd            }
                {MAIN    VMAIN1_PD       i_ecore.i_epath0_i_vmain1_pd            }
		}
	set sensor_line [lindex $sensor_array $i]
       	set line [format "%7d  %-5s  %-15s %.2f" $i  [lindex $sensor_line 0] [lindex $sensor_line 1] $temperature]
	puts "$line"
	}	
	reg write 0x6b2050 0
	reg write 0x6b2060 0
	puts "MFW calculated average temperature(celcius): [format %hi [expr [reg read [expr [expr (([reg read [expr [expr [reg read 0x8c20] | 0xe00000] + 0xc]] & 0xffff) << 2) | 0xe20000] + 20]]]]"
	 set public_offset [expr [reg read 0x8c20] | 0xe00000]
	 set public_port_offsize [reg read [expr $public_offset + 0x14]]
	 set public_port_offset [expr (($public_port_offsize & 0xffff) << 2) | 0xe20000]
	 set public_port_size [expr (($public_port_offsize & 0xffff0000) >> 16) << 2]
	 for {set port 0} {$port < 4} {incr port} {
		 set port_temp [reg read [expr $public_port_offset + $public_port_size*$port + 0xc80]]
		 puts "PHY port $port temperature: [format %d $port_temp]"
	 }

}


