


proc ah_efuse_info {} {
   
    set AVSC_MEMFUSE_CTRL 0x400
    set AVSC_MEMFUSE_RDDATA 0x408
    set AVSC_MEMFUSE_STAT 0x40c
    set AVSC_MEMFUSE_DIV 0x410
   
    # get AVS_WRAP block offset
    parse_rdf
    set offset [reg_offset -n AVS_WRAP_REG_AVS_IND]
    set avs_offset [lindex [split $offset "-"] 0]   
   
    # configure efuse clock divider 
    set clk_div_offset [expr {$avs_offset + 4*$AVSC_MEMFUSE_DIV}]
    reg write $clk_div_offset 0x5
    set val [reg read $clk_div_offset]
    #puts  "Read offset [format "0x%x" $clk_div_offset] val $val"

    # configure efuse control register (fuse_rstb=1)
    set ctrl_offset [expr {$avs_offset + 4*$AVSC_MEMFUSE_CTRL}]
    reg write $ctrl_offset 0xBEAF8000
    set val [reg read $ctrl_offset]
    #puts  "Read offset [format "0x%x" $ctrl_offset] val $val"

    delay us 1 

    # configure efuse control register (fuse_rstb=1, fuse_clksel=1, fuse_auto=1)
    # when efuse_auto=1 it increments the address upon every read or write
    reg write $ctrl_offset 0xBEAFA100
    set val3 [reg read $ctrl_offset]
    #puts  "Read offset [format "0x%x" $ctrl_offset] val $val"

    delay us 1

    # read efuse data from sequential memory addresses
    set data_offset [expr {$avs_offset + 4*$AVSC_MEMFUSE_RDDATA}]
    set stat_offset [expr {$avs_offset + 4*$AVSC_MEMFUSE_STAT}]
    for {set i 0} {$i < 16} {incr i} {
        reg write $data_offset 0x0
        set stat 0
        set timeout 50
        set line [expr {$i*2}]
        while {($stat != 1) && ($timeout > 0)} {
            set stat [reg read $stat_offset]
            delay us 1
            set timeout [expr {$timeout-1}]
        }
        set data [reg read $data_offset]
        puts  "lines $line-[expr {$line+1}]: \t $data"

        delay us 1
    }

    reg write $ctrl_offset 0xBEAF0000
}

proc efuse_info {} {
    if {[is_e4_K2]} {
        ah_efuse_info
    } else {
        dump_otp
    }
}

proc efuse_info_help {args} {
   set help_info     "Read eFuse information\n"
   append help_info  "Usage: efuse_info\n"
   add_help efuse_info $help_info
}

efuse_info_help
