proc extphy_get_triage_regs {port } {
	set PCS_DEVID 3
	set PMD_DEVID 1
	set USER_DEFINED_DEVID 0x1e
	set AN_DEVID 7

	extphy write $port $USER_DEFINED_DEVID 0x4110 0x0001
	extphy write $port $USER_DEFINED_DEVID 0x4111 0x0001
	extphy write $port $USER_DEFINED_DEVID 0x4113 0x1002

	puts "\[P$port\] AN Status                = [format %x [extphy read $port $AN_DEVID 1]]"
	puts "\[P$port\] AN Advertisement 1       = [format %x [extphy read $port $AN_DEVID 0x10]]"
	puts "\[P$port\] AN LP Base Page          = [format %x [extphy read $port $AN_DEVID 0x13]]"
	puts "\[P$port\] AN Tx Next Page 1        = [format %x [extphy read $port $AN_DEVID 0x16]]"
	puts "\[P$port\] AN Tx Next Page 2        = [format %x [extphy read $port $AN_DEVID 0x17]]"
	puts "\[P$port\] AN Tx Next Page 3        = [format %x [extphy read $port $AN_DEVID 0x18]]"
	puts "\[P$port\] AN LP Tx Next Page 1     = [format %x [extphy read $port $AN_DEVID 0x19]]"
	puts "\[P$port\] AN LP Tx Next Page 2     = [format %x [extphy read $port $AN_DEVID 0x1a]]"
	puts "\[P$port\] AN LP Tx Next Page 3     = [format %x [extphy read $port $AN_DEVID 0x1b]]"
	puts "\[P$port\] AN Control               = [format %x [extphy read $port $AN_DEVID 0x20]]"
	puts "\[P$port\] AN Status                = [format %x [extphy read $port $AN_DEVID 0x21]]"
	puts ""
	puts "\[P$port\] BASE-T PCS Status        = [format %x [extphy read $port $PCS_DEVID 1]]"
	puts "\[P$port\] BASE-T PCS Status        = [format %x [extphy read $port $PCS_DEVID 1]]"
	puts "\[P$port\] BASE-T PCS Status 2      = [format %x [extphy read $port $PCS_DEVID 8]]"
	puts "\[P$port\] BASE-T PCS Status 1      = [format %x [extphy read $port $PCS_DEVID 0x20]]"
	puts "\[P$port\] BASE-T PCS Status 2      = [format %x [extphy read $port $PCS_DEVID 0x21]]"
	puts "\[P$port\] BASE-T PCS Status 2      = [format %x [extphy read $port $PCS_DEVID 0x21]]"
	puts ""
	puts "\[P$port\] BASE-T PMD Status        = [format %x [extphy read $port $PMD_DEVID 1]]"
	puts "\[P$port\] BASE-T PMD Control 2     = [format %x [extphy read $port $PMD_DEVID 7]]"
	puts "\[P$port\] BASE-T PMD Status 2      = [format %x [extphy read $port $PMD_DEVID 8]]"
	puts "\[P$port\] BASE-T PMD Tx Disable    = [format %x [extphy read $port $PMD_DEVID 9]]"
	puts "\[P$port\] BASE-T PMD Sig Detect    = [format %x [extphy read $port $PMD_DEVID 0xa]]"
	puts "\[P$port\] BASE-T PMD Base-T Status = [format %x [extphy read $port $PMD_DEVID 0x81]]"
	puts ""
	puts "\[P$port\] User Defined XFI Status  = [format %x [extphy read $port $USER_DEFINED_DEVID 0x4602]]"
	extphy write $port $USER_DEFINED_DEVID 0x4110 0x2004
	extphy write $port $USER_DEFINED_DEVID 0x4111 0x2004
	extphy write $port $USER_DEFINED_DEVID 0x4113 0x2004

	puts "\[P$port\] XFI PCS Status           = [format %x [extphy read $port $PCS_DEVID 1]]"
	puts "\[P$port\] XFI PCS Status           = [format %x [extphy read $port $PCS_DEVID 1]]"
	puts "\[P$port\] XFI PCS Status 2         = [format %x [extphy read $port $PCS_DEVID 8]]"
	puts "\[P$port\] XFI PCS Status 1         = [format %x [extphy read $port $PCS_DEVID 0x20]]"
	puts "\[P$port\] XFI PCS Status 2         = [format %x [extphy read $port $PCS_DEVID 0x21]]"
	puts "\[P$port\] XFI PCS Status 2         = [format %x [extphy read $port $PCS_DEVID 0x21]]"
	puts "\[P$port\] XFI PCS Tx Disable       = [format %x [extphy read $port $PCS_DEVID 9]]"
	puts "\[P$port\] XFI PCS Sig Detect       = [format %x [extphy read $port $PCS_DEVID 0xa]]"
	puts ""
	puts "\[P$port\] XFI PMD Status           = [format %x [extphy read $port $PMD_DEVID 1]]"
	puts "\[P$port\] XFI PMD Status 2         = [format %x [extphy read $port $PMD_DEVID 8]]"
	
	extphy write $port $USER_DEFINED_DEVID 0x4110 0x0001
	extphy write $port $USER_DEFINED_DEVID 0x4111 0x0001
	extphy write $port $USER_DEFINED_DEVID 0x4113 0x1002
}

puts "\[P0\] AH MAC Status            = [format %x [reg read 0x800440]]"
puts "\[P0\] AH High Speed PCS Status = [format %x [reg read 0x840004]]"
puts "\[P0\] AH Low Speed PCS Status  = [format %x [reg read 0x802404]]"
extphy_get_triage_regs 0
puts "####################################################"
puts "####################################################"
puts "\[P1\] AH MAC Status            = [format %x [reg read 0x800840]]"
puts "\[P1\] AH PCS Status            = [format %x [reg read 0x880004]]"
puts "\[P1\] AH Low Speed PCS Status  = [format %x [reg read 0x802484]]"
extphy_get_triage_regs 1
exit
