interp alias {} fix_lldp_mac {}    nvmcfgT::fix_lldp_mac_addresses

# --------------------------------------------------------------
# This proc program LLDP MAC addresses to same mac addresses
# of devices 13-16
# --------------------------------------------------------------
proc nvmcfgT::fix_lldp_mac_addresses {} {

        variable nvm_cfg		
        variable nvm_config
        variable verify_cfg

        set verify_cfg 0
        
        set read_all 1
        set write_all 1

        set config_list [nvm_load 0 0 $read_all]
        set nvm_config [lindex $config_list 0]
        
        #MAC address option ids
        set mac_addr_opt 1
        set lldp_mac_addr_opt 99

        set no_ports 4
        set dev_idx 13
        set port_idx 1
        set mac_addr [get_formatted_val $mac_addr_opt true $dev_idx $no_ports]

        puts "Set mac $mac_addr to LLDP MAC of port $port_idx"
        set_feature_val $lldp_mac_addr_opt $mac_addr $port_idx $no_ports

        set dev_idx 14
        set port_idx 2
        set mac_addr [get_formatted_val $mac_addr_opt true $dev_idx $no_ports]
        puts "Set mac $mac_addr to LLDP MAC of port $port_idx"
        set_feature_val $lldp_mac_addr_opt $mac_addr $dev_idx $no_ports

        set dev_idx 15
        set port_idx 3
        set mac_addr [get_formatted_val $mac_addr_opt true $dev_idx $no_ports]
        puts "Set mac $mac_addr to LLDP MAC of port $port_idx"
        set_feature_val $lldp_mac_addr_opt $mac_addr $dev_idx $no_ports

        set dev_idx 16
        set port_idx 4
        set mac_addr [get_formatted_val $mac_addr_opt true $dev_idx $no_ports]
        puts "Set mac $mac_addr to LLDP MAC of port $port_idx"
        set_feature_val $lldp_mac_addr_opt $mac_addr $dev_idx $no_ports
        
        #Store to NVM after changing MAC addresses
        nvm_store $nvm_config $dev_idx $no_ports $write_all
}

