###########################################################################
# 
# Copyright(c) 2014-2017 Cavium, Inc., all rights reserved
# Proprietary and Confidential Information.
#
###########################################################################


proc set_10g_prbs { port lane } {
phy raw_write $port $lane 0x9010 0x0000

phy raw_write $port $lane 0x9010 0x0003
phy raw_read $port $lane 0x9010

# reg_name=Reg_tsc_pmd_x4_control, dev_adr=0, reg_adr=0x108c010, reg_width=0x10, reg_data=0x0
#x4 reset release

phy raw_write $port $lane 0xc010 0x0000
phy raw_write $port $lane 0xc010 0x0003
phy raw_read $port $lane 0xc010

lane_and_polarity_swap $port

# ln_dp_s_rstb release, reg_adr=0x908d081 reg_data=0x2
phy raw_write $port $lane 0x800d081 0x0002
phy raw_read $port $lane 0x800d081

# core_dp_s_rstb = 1, heartbeat_count_1us = 0x271, reg_adr=0x908d0f4 reg_data=0x2000
phy raw_write $port $lane 0x800d0f4 0x2271
phy raw_read $port $lane 0x800d0f4

prbs_helper $port $lane

# osr_mode_frc = 1, reg_adr=0x908d080 reg_data=0x8000
phy raw_write $port $lane 0x800d080 0x8000
phy raw_read $port $lane 0x800d080


# pll_mode = a, reg_adr=0x908d127 reg_data=0xa
phy raw_write $port $lane 0x800d127 0x000a
phy raw_read $port $lane 0x800d127

phy raw_write $port $lane 0x9000 0x6400
phy raw_read $port $lane 0x9000


# release RXP reset ??, reg_name=Reg_tsc_rx_x4_control0_pma_control_0, dev_adr=0, reg_adr=0x108c137, reg_width=0x10, reg_data=0x1

phy raw_write $port $lane 0xc137 0x0001
phy raw_read $port $lane 0xc137


# release TXP reset, reg_name=Reg_tsc_tx_x4_control0_misc, dev_adr=0, reg_adr=0x108c113, reg_width=0x10, reg_data=0x2

phy raw_write $port $lane 0xc113 0x01ca
phy raw_read $port $lane 0xc113


# reg_name=Reg_tsc_tx_x4_control0_misc, dev_adr=0, reg_adr=0x108c113, reg_width=0x10, reg_data=0x1

phy raw_write $port $lane 0xc113 0x01cb
phy raw_read $port $lane 0xc113


phy raw_write $port $lane 0x800d0d1 0x1
phy raw_write $port $lane 0x800d0e1 0x1

# Reg_tsc_sc_x4_control_control, dev_adr=0, reg_adr=0x108c050, reg_width=0x10, reg_data=0x1c

phy raw_write $port $lane 0xc050 0x001c
phy raw_read $port $lane 0xc050

phy raw_write $port $lane 0xc050 0x011c
phy raw_read $port $lane 0xc050

phy raw_read $port $lane 0x800d0d9

phy raw_read $port $lane 0x800d0d9
phy raw_read $port $lane 0x800d0d9
phy raw_read $port $lane 0x800d0d9
phy raw_read $port $lane 0x800d0d9
phy raw_read $port $lane 0x800d0d9
phy raw_read $port $lane 0x800d0d9
phy raw_read $port $lane 0x800d0d9
phy raw_read $port $lane 0x800d0d9
phy raw_read $port $lane 0x800d0d9
phy raw_read $port $lane 0x800d0d9
}

proc lane_and_polarity_swap { port } {
  global board
  if { $board == "T8004" } {
    puts "lane_and_polarity_swap"

	  #Write the default
    phy raw_write $port 0 0x800d0fb 0x820
    phy raw_write $port 0 0x800d0fc 0x403
    phy raw_write $port 0 0x800d0fd 0x302

    # Tx lane polarity
    phy raw_write 1 0 0x800d0e3 1
    phy raw_write 1 1 0x800d0e3 0
    phy raw_write 1 2 0x800d0e3 1
    phy raw_write 1 3 0x800d0e3 0

    # Rx lane polarity
    phy raw_write 1 0 0x800d0d3 1
    phy raw_write 1 1 0x800d0d3 1
    phy raw_write 1 2 0x800d0d3 1
    phy raw_write 1 3 0x800d0d3 0

    #PCS swap
    #phy raw_write $port 0 0x9003 0x78
    #lane swap
    phy raw_write $port 0 0x800d0fb 0xc01

    phy raw_write $port 0 0x800d0fc 0xc02
    phy raw_write $port 0 0x800d0fd 0x201
  } elseif { $board != "T8003" } {
    puts " EERROORR: Please type: set board <T8003 or T8004>"
  }
}

proc falcon_lane_and_polarity_swap { port } {
  global board
  if { $board == "T8004" } {
    puts "falcon_lane_and_polarity_swap"
    phy raw_write 0 0 0x9003 0x5e4
    phy raw_write 0 0 0x800d10b 0x820
    phy raw_write 0 0 0x800d10c 0x403
    phy raw_write 0 0 0x800d10d 0x302
    
    # Tx lane polarity
    phy raw_write 0 0 0x800d173 0
    phy raw_write 0 1 0x800d173 0
    phy raw_write 0 2 0x800d173 0
    phy raw_write 0 3 0x800d173 0

    # Rx lane polarity
    phy raw_write 0 0 0x800d163 1
    phy raw_write 0 1 0x800d163 0
    phy raw_write 0 2 0x800d163 1
    phy raw_write 0 3 0x800d163 0

    phy raw_write 0 0 0x9003 0x163
    #lane swap
    phy raw_write $port 0 0x800d10b 0x440
    phy raw_write $port 0 0x800d10c 0xc23
    phy raw_write $port 0 0x800d10d 0x002

    # phy raw_write 0 0 0x800d10c 0x403
    # phy raw_write 0 0 0x800d10d 0x302
  } elseif { $board != "T8003" } {
    puts " EERROORR: Please type: set board <T8003 or T8004>"
  }
}
  # phy raw_write $port 0 0x800d10b 0xc20
  # phy raw_write $port 0 0x800d10c 0xc22
  # phy raw_write $port 0 0x800d10b 0x820

proc set_10g_falcon_prbs { port lane } {

  phy raw_write $port $lane 0xc050 0x0000
  phy raw_write $port $lane 0x9010 0x0000

  phy raw_write $port $lane 0x9010 0x0003
  phy raw_read $port $lane 0x9010
  
  phy raw_write $port $lane 0xc010 0x0000
  phy raw_write $port $lane 0xc010 0x0003
  phy raw_read $port $lane 0xc010

  falcon_lane_and_polarity_swap $port

  phy raw_write $port $lane 0x800d0b1 0x0002
  phy raw_read $port $lane 0x800d0b1

  phy raw_write $port $lane 0x800d104 0x0071
  phy raw_read $port $lane 0x800d104
  
  phy raw_write $port $lane 0x800d147 0x0004
  phy raw_read $port $lane 0x800d147
  
  phy raw_write $port $lane 0x800d104 0x2071
  phy raw_read $port $lane 0x800d104
  
  phy raw_write $port $lane 0x800d0b0 0x8000
  phy raw_read $port $lane 0x800d0b0

  phy raw_write $port $lane 0x9000 0x180
  phy raw_read $port $lane 0x9000

  phy raw_write $port $lane 0x9003 0x5e4
  phy raw_read $port $lane 0x9003

  phy raw_write $port $lane 0xc137 0x0001
  phy raw_read $port $lane 0xc137

  phy raw_write $port $lane 0xc113 0x01ca
  phy raw_read $port $lane 0xc113

  phy raw_write $port $lane 0xc113 0x01c3
  phy raw_read $port $lane 0xc113

  phy raw_write $port $lane 0x800d161 1
  phy raw_read $port $lane 0x800d161

  phy raw_write $port $lane 0x800d171 1
  phy raw_read $port $lane 0x800d171

  phy raw_write $port $lane 0xc050 0x0002
  phy raw_read $port $lane 0xc050

  phy raw_write $port $lane 0xc050 0x00102
  phy raw_read $port $lane 0xc050

  phy raw_read $port $lane 0x800d169
  phy raw_read $port $lane 0x800d169
}

proc set_40g_loopback {port lane gloop} {
  phy raw_write $port 6 0xc050  0x1
  #phy raw_write $port 0 0x9010 0x0000
  #phy raw_read $port 0 0x9010

  #phy raw_write $port 0 0x9010 0x0003
  #phy raw_read $port 0 0x9010
	#phy raw_write $port 0 0x9003 0x78
  phy raw_write $port 0 0x9003 0x78

  # reg_name=Reg_tsc_pmd_x4_control, dev_adr=0, reg_adr=0x108c010, reg_width=0x10, reg_data=0x0
  #x4 reset release
  phy raw_write $port 6 0xc010 0x0000
  phy raw_write $port 6 0xc010 0x0003
  phy raw_read $port 0 0xc010

  lane_and_polarity_swap $port

  # ln_dp_s_rstb release, reg_adr=0x908d081 reg_data=0x2
  phy raw_write $port 6 0x800d081 0x0002
  phy raw_read $port 6 0x800d081

  # core_dp_s_rstb = 1, heartbeat_count_1us = 0x271, reg_adr=0x908d0f4 reg_data=0x2000
  phy raw_write $port 6 0x800d0f4 0x2271
  phy raw_read $port 0 0xd0f4

  prbs_helper $port 0
  prbs_helper $port 1
  prbs_helper $port 2
  prbs_helper $port 3

  # 0xr_mode_frc = 1, reg_adr=0x908d080 reg_data=0x8000
  phy raw_write $port 6 0x800d080 0x8000
  phy raw_read $port 6 0x800d080

  # pll_mode = a, reg_adr=0x908d127 reg_data=0xa
  phy raw_write $port 0 0x800d127 0x000a
  phy raw_read $port 0 0x800d127

  # reg_name=Reg_tsc_main0_setup, dev_adr=0, reg_adr=0x1089000, reg_width=0x10, reg_data=0x6400
  # phy raw_write $port 0 0x9000 0x6400
  phy raw_write $port 0 0x9000 0x6440
  phy raw_read $port 0 0x9000

  # release RXP reset ??, reg_name=Reg_tsc_rx_x4_control0_pma_control_0, dev_adr=0, reg_adr=0x108c137, reg_width=0x10, reg_data=0x1
  phy raw_write $port 6 0xc137 0x0001
  phy raw_read $port 0 0xc137

  # reg_name=Reg_tsc_tx_x4_control0_misc, dev_adr=0, reg_adr=0x108c113, reg_width=0x10, reg_data=0x1
  phy raw_write $port 6 0xc113 0xc1c8
  phy raw_read $port 0 0xc113
  # Default value is not ok TX_X2_CONTROL0_MLD_SWAP_COUNT
  phy raw_write $port 0 0xa000 0xfffc

  # Reg_tsc_sc_x4_control_control, dev_adr=0, reg_adr=0x108c050, reg_width=0x10, reg_data=0x1c
  # phy raw_write $port 0 0xc050 0x001c
  phy raw_write $port 0 0xc050 0x0021
  phy raw_read $port 0 0xc050

  # phy raw_write $port 0 0xc050 0x011c
  phy raw_write $port 0 0xc050 0x0121
  phy raw_read $port 0 0xc050

  # RX_X4_Control (setup decode mode, deskew mode and descrambler mode)
  # phy raw_write $port 6 0xc130 0x33c0
  phy raw_write $port 6 0xc130 0x4b30
  phy raw_read $port 0 0xc130

  # Set up RX_X4_Control0_decode_control setup block_sync_mode
  phy raw_write $port 6 0xc134 0x2872
  phy raw_read $port 0 0xc134

  # release TXP reset, reg_name=Reg_tsc_tx_x4_control0_misc, dev_adr=0, reg_adr=0x108c113, reg_width=0x10, reg_data=0x2
  phy raw_write $port 6 0xc113 0xc1ca
  phy raw_read $port 0 0xc113

  # reg_name=Reg_tsc_tx_x4_control0_misc, dev_adr=0, reg_adr=0x108c113, reg_width=0x10, reg_data=0x1
  phy raw_write $port 6 0xc113 0xc1cb
  phy raw_read $port 0 0xc113

  # PMD LOOPBACK
  phy raw_read $port 0 0x800d0d2

  if { $gloop == 1 } {
    phy raw_write $port 6 0x800d0d2 0x7
    phy raw_read $port 0 0x800d0d2
  }

  # PCS loop back (not set)
  phy raw_read $port 0 0x9009

  #pcs live link status 0x1b is good link AM Lock - Deskew - 0 - link status - sync status
  phy raw_read $port 0 0xc154
}

proc set_10g_loopback { port lane gloop} {

	global board
       if { $board == "T8004" } {
	 if {$gloop == 1 } {
           #set the default lane swapping values in the PCS
	   phy raw_write $port 0 0x9003 0xe4
         } else {
	   phy raw_write $port 0 0x9003 0x78
           lane_and_polarity_swap $port
         }
       }

	 # reg_name=Reg_tsc_pmd_x4_control, dev_adr=0, reg_adr=0x108c010, reg_width=0x10, reg_data=0x0
	 #x4 reset release

	 ## phy raw_write  $port  0xc010 0x0000 
	 ## phy raw_write  $port  0xc010 0x0003 
	 ## phy raw_read  $port  0xc010 
	 phy raw_write $port $lane 0xc010 0
	 phy raw_write $port $lane 0xc010 3
	 phy raw_read $port $lane 0xc010 

	 # ln_dp_s_rstb release, reg_adr=0x908d081 reg_data=0x2
	 ## phy raw_write  $port 1.0 0xd081 0x0002
	 ## phy raw_read  $port 1.0 0xd081 
	 phy raw_write $port $lane 0x800d081 2
	 phy raw_read $port $lane 0x800d081 

	 # core_dp_s_rstb = 1, heartbeat_count_1us = 0x271, reg_adr=0x908d0f4 reg_data=0x2000
	 ## phy raw_write  $port 1.0 0xd0f4 0x2271
	 ## phy raw_read  $port 1.0 0xd0f4 
	 phy raw_write $port $lane 0x800d0f4 0x2271
	 phy raw_read $port $lane 0x800d0f4 

   prbs_helper $port $lane

	 # 0xr_mode_frc = 1, reg_adr=0x908d080 reg_data=0x8000
	 ## phy raw_write  $port 1.0 0xd080 0x8000
	 ## phy raw_read  $port 1.0 0xd080 
	 phy raw_write $port $lane 0x800d080 0x8000
	 phy raw_read $port $lane 0x800d080

	 # pll_mode = a, reg_adr=0x908d127 reg_data=0xa
	 #phy raw_write  $port 1.0 0xd127 0x000a
	 #phy raw_read  $port 1.0 0xd127 
	 phy raw_write $port $lane 0x800d127 0x000a 
	 phy raw_read $port $lane 0x800d127 

	 # reg_name=Reg_tsc_main0_setup, dev_adr=0, reg_adr=0x1089000, reg_width=0x10, reg_data=0x6400
	 phy raw_write $port $lane 0x9000 0x6400
	 phy raw_read $port $lane 0x9000 


	 # release RXP reset ??, reg_name=Reg_tsc_rx_x4_control0_pma_control_0, dev_adr=0, reg_adr=0x108c137, reg_width=0x10, reg_data=0x1

	 phy raw_write $port $lane 0xc137 0x0001
	 phy raw_read $port $lane 0xc137 


	 # release TXP reset, reg_name=Reg_tsc_tx_x4_control0_misc, dev_adr=0, reg_adr=0x108c113, reg_width=0x10, reg_data=0x2

	 phy raw_write $port $lane 0xc113 0x01ca
	 phy raw_read $port $lane 0xc113 


	 # reg_name=Reg_tsc_tx_x4_control0_misc, dev_adr=0, reg_adr=0x108c113, reg_width=0x10, reg_data=0x1

	 phy raw_write $port $lane 0xc113 0x01cb
	 phy raw_read $port $lane 0xc113 


	 # Reg_tsc_sc_x4_control_control, dev_adr=0, reg_adr=0x108c050, reg_width=0x10, reg_data=0x1c

	 phy raw_write $port $lane 0xc050 0x001c
	 phy raw_read $port $lane 0xc050 

	 phy raw_write $port $lane 0xc050 0x011c
	 phy raw_read $port $lane 0xc050 

	 if {$gloop == 1} {
	   # PMD LOOPBACK
	   phy raw_read $port $lane 0x800d0d2
	   phy raw_write $port $lane 0x800d0d2 0x7
         } else {
	   # PMD LOOPBACK
	   phy raw_read $port $lane 0x800d0d2
	   phy raw_write $port $lane 0x800d0d2 0x6
         }

	 # pcs live link status
	 phy raw_read $port $lane 0xc154 

}

proc set_1lane_loopback_falcon { port lane speed first gloop } {
  if {$first == 1} {
    phy raw_write $port $lane 0x9010 0x0000

    phy raw_write $port $lane 0x9010 0x0003
    phy raw_read $port $lane 0x9010
  }

  phy raw_write $port $lane 0xc010 0x0000
  phy raw_write $port $lane 0xc010 0x0003
  phy raw_read $port $lane 0xc010

  falcon_lane_and_polarity_swap $port

  phy raw_write $port $lane 0x800d0b1 0x0002
  phy raw_read $port $lane 0x800d0b1

  phy raw_write $port $lane 0x800d104 0x0071
  phy raw_read $port $lane 0x800d104

  if { $speed == 10 } {
    phy raw_write $port $lane 0x800d147 0x0004
  } elseif { $speed == 20 } {
    phy raw_write $port $lane 0x800d147 0x0004
  } elseif { $speed == 25 } {
    phy raw_write $port $lane 0x800d147 0x0007
  }
  phy raw_read $port $lane 0x800d147

  phy raw_write $port $lane 0x800d104 0x2071
  phy raw_read $port $lane 0x800d104

  phy raw_write $port $lane 0x800d0b0 0x8001
  phy raw_read $port $lane 0x800d0b0

  phy raw_write $port $lane 0x9000 0x180
  phy raw_read $port $lane 0x9000

  # phy raw_write $port $lane 0x9003 0x5e4
  # phy raw_read $port $lane 0x9003

  phy raw_write $port $lane 0xc137 0x0001
  phy raw_read $port $lane 0xc137

  phy raw_write $port $lane 0xc113 0x01ca
  phy raw_read $port $lane 0xc113

  phy raw_write $port $lane 0xc113 0x01c3
  phy raw_read $port $lane 0xc113

  phy raw_write $port $lane 0xc050 0x0002
  phy raw_read $port $lane 0xc050

  phy raw_write $port $lane 0xc050 0x00102
  phy raw_read $port $lane 0xc050

  if { $gloop == 1 } {
    phy raw_read $port $lane 0x800d162
    phy raw_write $port $lane 0x800d162 0xb
  }

  phy raw_read $port $lane 0xc161
}

proc set_4lane_loopback_falcon { port lane speed gloop } {
  phy raw_write 0 6 0xc050 0x0000
  phy raw_write 0 0 0x9010 0x0000

  phy raw_read 0 0 0x9010
  phy raw_write 0 0 0x9010 0x0003
  phy raw_read 0 0 0x9010

  # reg_name=Reg_tsc_pmd_x4_control, dev_adr=0, reg_adr=0x108c010, reg_width=0x10, reg_data=0x0
  #x4 reset release
  phy raw_write 0 6 0xc010 0x0000
  phy raw_write 0 6 0xc010 0x0003
  phy raw_read 0 0 0xc010

  falcon_lane_and_polarity_swap 0

  phy raw_write 0 6 0x800d0b1 0x0002
  phy raw_read 0 0 0x800d0b1

  phy raw_write 0 6 0x9200 0x0754
  phy raw_read 0 0 0x9200
  # ln_dp_s_rstb release, reg_adr=0x908d081 reg_data=0x2
  phy raw_write 0 6 0x800d081 0x0002
  phy raw_read 0 6 0x800d081

  # core_dp_s_rstb = 1, heartbeat_count_1us = 0x271, reg_adr=0x908d0f4 reg_data=0x2000
  phy raw_write 0 6 0x800d104 0x0071
  phy raw_read 0 0 0xd0f4

  phy raw_write 0 6 0x800d0b0 0x8001
  phy raw_read 0 0 0x800d0b0

  phy raw_write 0 0 0x800d147 0x0004
  phy raw_read 0 0 0x800d147

  phy raw_write 0 0 0x800d104 0x2071
  phy raw_read 0 0 0x800d104

  # pll_mode = a, reg_adr=0x908d127 reg_data=0xa
  phy raw_write 0 0 0x800d127 0x000a
  phy raw_read 0 0 0x800d127

  # phy raw_write 0 0 0x9003 0x5e4
  # phy raw_read 0 0 0x9003

  # reg_name=Reg_tsc_main0_setup, dev_adr=0, reg_adr=0x1089000, reg_width=0x10, reg_data=0x6400
  # phy raw_write 0 0 0x9000 0x6400
  phy raw_write 0 0 0x9000 0x1c0
  phy raw_read 0 0 0x9000

  # release RXP reset ??, reg_name=Reg_tsc_rx_x4_control0_pma_control_0, dev_adr=0, reg_adr=0x108c137, reg_width=0x10, reg_data=0x1
  phy raw_write 0 6 0xc137 0x0001
  phy raw_read 0 0 0xc137

  # reg_name=Reg_tsc_tx_x4_control0_misc, dev_adr=0, reg_adr=0x108c113, reg_width=0x10, reg_data=0x1
  phy raw_write 0 6 0xc113 0xa1c4
  phy raw_read 0 0 0xc113

  # Default value is not ok TX_X2_CONTROL0_MLD_SWAP_COUNT
  phy raw_write 0 0 0xa000 0xfffc

  # Reg_tsc_sc_x4_control_control, dev_adr=0, reg_adr=0x108c050, reg_width=0x10, reg_data=0x1c
  # phy raw_write 0 0 0xc050 0x001c
  phy raw_write 0 0 0xc050 0x0029
  phy raw_read 0 0 0xc050

  # phy raw_write 0 0 0xc050 0x011c
  phy raw_write 0 0 0xc050 0x0129
  phy raw_read 0 0 0xc050

  # RX_X4_Control (setup decode mode, deskew mode and descrambler mode)
  phy raw_write 0 6 0xc130 0xa280
  phy raw_read 0 0 0xc130

  # Set up RX_X4_Control0_decode_control setup block_sync_mode
  phy raw_write 0 6 0xc134 0x2070
  phy raw_read 0 0 0xc134

  # release TXP reset, reg_name=Reg_tsc_tx_x4_control0_misc, dev_adr=0, reg_adr=0x108c113, reg_width=0x10, reg_data=0x2
  phy raw_write 0 6 0xc113 0xa1c6
  phy raw_read 0 0 0xc113

  # reg_name=Reg_tsc_tx_x4_control0_misc, dev_adr=0, reg_adr=0x108c113, reg_width=0x10, reg_data=0x1
  phy raw_write 0 6 0xc113 0xa1c7
  phy raw_read 0 0 0xc113

  # PMD LOOPBACK
  phy raw_write 0 0 0x800d162

  if { $gloop == 1 } {
    phy raw_write 0 6 0x800d162 0xb
    phy raw_read 0 0 0x800d162
  }

  # PCS loop back (not set)
  phy raw_read 0 0 0x9009

  #pcs live link status 0x1b is good link AM Lock - Deskew - 0 - link status - sync status
  # phy raw_read 0 0 0xc154
  phy raw_read 0 0 0xc161

}

proc program_nig {{via_mcp 0}} {
	# Enable NIG RX/TX
set NIG_REG_MAC_IN_EN  0x500e10
set NIG_REG_MAC_OUT_EN  0x500e14
set NIG_REG_RX_LLH_NCSI_MCP_MASK 0x501128
set NIG_REG_RX_LLH_NCSI_MCP_IVLAN 0x50112c

set NIG_REG_TX_LLH_NCSI_NTWK_MASK 0x502144
set NIG_REG_RX_LLH_L2FILT_MCP_RULE0 0x5011a8

set NIG_REG_MNG_TO_MCP 0x500834
	# To route packet from NIG to BMB, the following condition must be met:
	# 1. NCSI rule to forward to BMB
	# This will be handled by NIG RX filters
	# 2. Innver VLAN rule
	# 3. Outer VLAN rule
	# 2 and 3 are enabled by just enabling RULE0 while keeping inner vlan and outer vlan tag disabled.

	# Enable NIG RX filters from host -> MCP (ARP, unicast, multicast, broadcast)
	reg write $NIG_REG_RX_LLH_NCSI_MCP_MASK [expr (1<<13) | (0x1f)]
	# Enable packets with or without vlan
	reg write $NIG_REG_RX_LLH_NCSI_MCP_IVLAN 3
	# Enable NIG TX to the network
	reg write $NIG_REG_TX_LLH_NCSI_NTWK_MASK [expr (1<<13) | (0x1f)]

	# Enable L2 Filtering RULE0
	# reg write $NIG_REG_RX_LLH_L2FILT_MCP_RULE0 1

	reg write $NIG_REG_MAC_IN_EN 0x1
	reg write $NIG_REG_MAC_OUT_EN 0x1

	reg write $NIG_REG_MNG_TO_MCP $via_mcp
	puts "NIG programmed"

}

proc test_loopback {port lane speed gloop swap} {



   if {$port == 1 } {
     if {$speed == 10 } {
	     puts "Set 10G Loopback"
	     set_10g_loopback 0 $lane $gloop 
     } else {
	     puts "Set 40G Loopback"
	     set_40g_loopback $port 0 $gloop 
     }
   } else {
     if {$speed == 10 } {
	     puts "Set Falcon 10G loopback"
	     set_1lane_loopback_falcon $port $lane 10 1 $gloop
     } else {
	     puts "Set 40G Loopback"
	     set_4lane_loopback_falcon 0 0 40 $gloop
     }
   }

   #phy core_write 1 0x600 0x40 0
   #reg write 0x9060 0x1ee
   #reg write 0x9060 0x1ef

	 puts "Enable MAC"
	 phy mac_lb $lane dis

         puts "Program NIG"
	 reg write 0x500e10 1
	 reg write 0x500e14 1

	 puts "Loading Driver [ expr $lane + 1]"
	 driver load

	 puts "Clear NIG attentions"
	 for {set i 0x84a8} {$i < 0x85bc} {incr i 36} {reg write $i [expr [reg read $i] & ~[expr 3 << 22]] }

   if {$speed == 40 } {
     reg write 0x218200 0 
     reg write 0x218204 $swap
   } else {
     if {$port == 0 } {
       #CNIG_NW_PORT_MODE
       reg write 0x218200 0x3 
     }
   }
	 puts "Do: l2pkt send 1 0"
}


proc prbs_helper { port lane } {
  phy raw_write $port $lane 0x800d110 0x180
  phy raw_write $port $lane 0x800d111 0x66
  phy raw_write $port $lane 0x800d118 0x302
}

#proc set_gloop { port lane val} {
#  if {$val == 1} {
#   phy raw_write $port $lane 0x800d0d2 7 
#  } else {
#   phy raw_write $port $lane 0x800d0d2 6 
#  }
#}


proc clmac_stat {} {
	 for {set i 0} {$i < 0x70} {incr i 1} {puts "MIB[expr $i]: =  [expr [phy core_read 0 $i]]"}
	 for {set i 0} {$i < 0x70} {incr i 1} { phy core_read 0 $i 0}
}

proc reset_cnig {} {
  #reset bit 0
	 reg write 0x9060 [expr [reg read 0x9060] & 0xfffffffe] 
	 reg write 0x9060 [expr [expr [reg read 0x9060] & 0xfffffffe ] | 1] 
}

proc mac_soft_reset { lane } {
	#Assert soft reset
  phy core_write $lane 0x600 0x40 0
}

proc tsc_reg_dump {port lane } {
  puts "0xc050 = [format %x [expr [phy raw_read $port 0 0xc050] ]]"  
  puts "0xc050 = [format %x [expr [phy raw_read $port 1 0xc050] ]]"  
  puts "0xc050 = [format %x [expr [phy raw_read $port 2 0xc050] ]]"  
  puts "0xc050 = [format %x [expr [phy raw_read $port 3 0xc050] ]]"  
  puts "0x9003 = [format %x [expr [phy raw_read $port 0 0x9003] ]]" 
  puts "0xc010 = [format %x [expr [phy raw_read $port 0 0xc010] ]]"
  puts "0xc010 = [format %x [expr [phy raw_read $port 1 0xc010] ]]"
  puts "0xc010 = [format %x [expr [phy raw_read $port 2 0xc010] ]]"
  puts "0xc010 = [format %x [expr [phy raw_read $port 3 0xc010] ]]"
  puts "0x800d081 = [format %x [expr [phy raw_read $port 0 0x800d081] ]]"
  puts "0x800d081 = [format %x [expr [phy raw_read $port 1 0x800d081] ]]"
  puts "0x800d081 = [format %x [expr [phy raw_read $port 2 0x800d081] ]]"
  puts "0x800d081 = [format %x [expr [phy raw_read $port 3 0x800d081] ]]"
  puts "0x800d0f4 = [format %x [expr [phy raw_read $port 0 0x800d0f4] ]]"
  puts "0x800d0f4 = [format %x [expr [phy raw_read $port 1 0x800d0f4] ]]"
  puts "0x800d0f4 = [format %x [expr [phy raw_read $port 2 0x800d0f4] ]]"
  puts "0x800d0f4 = [format %x [expr [phy raw_read $port 3 0x800d0f4] ]]"
  puts "0x800d080 = [format %x [expr [phy raw_read $port 0 0x800d080] ]]"
  puts "0x800d080 = [format %x [expr [phy raw_read $port 1 0x800d080] ]]"
  puts "0x800d080 = [format %x [expr [phy raw_read $port 2 0x800d080] ]]"
  puts "0x800d080 = [format %x [expr [phy raw_read $port 3 0x800d080] ]]"
  puts "0x800d127 = [format %x [expr [phy raw_read $port 0 0x800d127] ]]"
  puts "0x9000 = [format %x [expr [phy raw_read $port 0 0x9000] ]]"
  puts "0xc137 = [format %x [expr [phy raw_read $port 0 0xc137] ]]"
  puts "0xc137 = [format %x [expr [phy raw_read $port 1 0xc137] ]]"
  puts "0xc137 = [format %x [expr [phy raw_read $port 2 0xc137] ]]"
  puts "0xc137 = [format %x [expr [phy raw_read $port 3 0xc137] ]]"
  puts "0xc113 = [format %x [expr [phy raw_read $port 0 0xc113] ]]"
  puts "0xc113 = [format %x [expr [phy raw_read $port 1 0xc113] ]]"
  puts "0xc113 = [format %x [expr [phy raw_read $port 2 0xc113] ]]"
  puts "0xc113 = [format %x [expr [phy raw_read $port 3 0xc113] ]]"
  puts "0xa000 = [format %x [expr [phy raw_read $port 0 0xa000] ]]" 
  puts "0xc050 = [format %x [expr [phy raw_read $port 0 0xc050] ]]"
  puts "0xc130 = [format %x [expr [phy raw_read $port 0 0xc130] ]]"
  puts "0xc130 = [format %x [expr [phy raw_read $port 1 0xc130] ]]"
  puts "0xc130 = [format %x [expr [phy raw_read $port 2 0xc130] ]]"
  puts "0xc130 = [format %x [expr [phy raw_read $port 3 0xc130] ]]"
  puts "0xc134 = [format %x [expr [phy raw_read $port 0 0xc134] ]]"
  puts "0xc134 = [format %x [expr [phy raw_read $port 1 0xc134] ]]"
  puts "0xc134 = [format %x [expr [phy raw_read $port 2 0xc134] ]]"
  puts "0xc134 = [format %x [expr [phy raw_read $port 3 0xc134] ]]"
  puts "0xc113 = [format %x [expr [phy raw_read $port 0 0xc113] ]]"
  puts "0xc113 = [format %x [expr [phy raw_read $port 1 0xc113] ]]"
  puts "0xc113 = [format %x [expr [phy raw_read $port 2 0xc113] ]]"
  puts "0xc113 = [format %x [expr [phy raw_read $port 3 0xc113] ]]"
  puts "0x800d0d2 = [format %x [expr [phy raw_read $port 0 0x800d0d2] ]]"
  puts "0x800d0d2 = [format %x [expr [phy raw_read $port 1 0x800d0d2] ]]"
  puts "0x800d0d2 = [format %x [expr [phy raw_read $port 2 0x800d0d2] ]]"
  puts "0x800d0d2 = [format %x [expr [phy raw_read $port 3 0x800d0d2] ]]"
  puts "0x9009 = [format %x [expr [phy raw_read $port 0 0x9009] ]]"
  puts "0xc154 = [format %x [expr [phy raw_read $port 0 0xc154] ]]"
  puts "0x800d0e3 = [format %x [expr [phy raw_read 1 0 0x800d0e3] ]]" 
  puts "0x800d0e3 = [format %x [expr [phy raw_read 1 1 0x800d0e3] ]]" 
  puts "0x800d0e3 = [format %x [expr [phy raw_read 1 2 0x800d0e3] ]]" 
  puts "0x800d0e3 = [format %x [expr [phy raw_read 1 3 0x800d0e3] ]]" 
  puts "0x800d0d3 = [format %x [expr [phy raw_read 1 0 0x800d0d3] ]]" 
  puts "0x800d0d3 = [format %x [expr [phy raw_read 1 1 0x800d0d3] ]]" 
  puts "0x800d0d3 = [format %x [expr [phy raw_read 1 2 0x800d0d3] ]]" 
  puts "0x800d0d3 = [format %x [expr [phy raw_read 1 3 0x800d0d3] ]]" 
  puts "0x800d0fb = [format %x [expr [phy raw_read $port 0 0x800d0fb] ]]" 
  puts "0x800d0fc = [format %x [expr [phy raw_read $port 0 0x800d0fc] ]]" 
  puts "0x800d0fd = [format %x [expr [phy raw_read $port 0 0x800d0fd] ]]" 
  puts "0x800d110 = [format %x [expr [phy raw_read $port 0 0x800d110] ]]" 
  puts "0x800d111 = [format %x [expr [phy raw_read $port 0 0x800d111] ]]" 
  puts "0x800d118 = [format %x [expr [phy raw_read $port 0 0x800d118] ]]" 
}
