<?xml version="1.0"?>
<instrumentationManifest xsi:schemaLocation="http://schemas.microsoft.com/win/2004/08/events eventman.xsd" xmlns="http://schemas.microsoft.com/win/2004/08/events" xmlns:win="http://manifests.microsoft.com/win/2004/08/windows/events" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:trace="http://schemas.microsoft.com/win/2004/08/events/trace">
	<instrumentation>
		<counters schemaVersion="1.1" xmlns="http://schemas.microsoft.com/win/2005/12/counters">
			<provider providerName="CavmProvider" providerGuid="{e2a4ae01-38db-4da2-84fe-00afeae9893e}" applicationIdentity="qenda.sys" providerType="kernelMode" callback="custom">
				<counterSet name="Cavium FastLinQ Port Counters" symbol="PortCounters" guid="{356dab64-5a77-4f66-abe4-3066e733062e}" uri="Cavium.qend.PortCounters" description="This set contains port counters" instances="multipleAggregate">
					<structs>
						<struct name="PortCounterStruct" type="pcw_port_counters_t"></struct>
					</structs>
					<counter name="Pause Frames Transmitted" uri="Cavium.qend.PortCounters.Pause_Frames_Transmitted" description="The number of pause frames transmitted." id="1" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="PortCounterStruct" field="u64PauseFramesTransmitted"></counter>
					<counter name="Pause Frames Received" uri="Cavium.qend.PortCounters.Pause_Frames_Received" description="The number of pause frames received." id="2" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="PortCounterStruct" field="u64PauseFramesReceived"></counter>
					<counter name="PFC Frames Transmitted" uri="Cavium.qend.PortCounters.PFC_Frames_Transmitted" description="The number of PFC frames transmitted." id="3" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="PortCounterStruct" field="u64PFCFramesTransmitted"></counter>
					<counter name="PFC Frames Received" uri="Cavium.qend.PortCounters.PFC_Frames_Received" description="The number of PFC frames received." id="4" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="PortCounterStruct" field="u64PFCFramesReceived"></counter>
				</counterSet>
				<counterSet name="Cavium FastLinQ Congestion Control" symbol="CongestionCounters" guid="{5fb4daa5-c396-42cc-83d6-9e5ce9d8092f}" uri="Cavium.qend.CongestionCounters" description="This set contains congestion control counters" instances="multipleAggregate">
					<structs>
						<struct name="CongestionCounterStruct" type="pcw_congestion_counters_t"></struct>
					</structs>
					<counter name="Notification Point - CNPs Sent Successfully" uri="Cavium.qend.CongestionCounters.Notification_Point_CNPs_Sent_Successfully" description="The number of congestion notification packets (CNPs) successfully sent by the notification point." id="1" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="CongestionCounterStruct" field="u64NotificationPointCNPsSentSuccessfully"></counter>
					<counter name="Notification Point - RoCEv2 ECN Marked Packets" uri="Cavium.qend.CongestionCounters.Notification_Point_RoCEv2_ECN_Marked_Packets" description="Number of RoCEv2 packets that were marked as congestion encountered." id="2" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="CongestionControlCounterStruct" field="u64NotificationPointRoCEv2ECNMarkedPackets"></counter>
					<counter name="Reaction Point - CNPs Received Successfully" uri="Cavium.qend.CongestionCounters.Reaction_Point_CNPs_Received_Successfully" description="The number of congestion notification packets (CNPs) successfully received by the notification point." id="3" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="CongestionCounterStruct" field="u64ReactionPointCNPsReceivedSuccessfully"></counter>
				</counterSet>
				<counterSet name="Cavium FastLinQ RDMA Error Counters" symbol="RDMACounters" guid="{fc225f41-503b-48cf-8f49-55205b43aa13}" uri="Cavium.qend.RDMACounters" description="This set contains RDMA error counters" instances="multipleAggregate">
					<structs>
						<struct name="RDMACounterStruct" type="pcw_rdma_counters_t"></struct>
					</structs>
					<counter name="CQ Overflow" uri="Cavium.qend.RDMACounters.CQ_Overflow_Errors" description="The number of completion instances when no space on CQ despite actual execution of the message and acknowledgement." id="1" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMACounterStruct" field="u64CQOverflowErrors"></counter>
					<counter name="Requestor Local QP Operation" uri="Cavium.qend.RDMACounters.Local_QP_Operation_Errors" description="The number of errors occurred in the requester’s local channel interface that can be associated with a certain WQE." id="2" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAControlCounterStruct" field="u64RequestorLocalQPOperationErrors"></counter>
					<counter name="Requestor Bad Response" uri="Cavium.qend.RDMACounters.Requestor_Bad_Response" description="The number of times an unexpected transport layer opcode was returned by the responder." id="3" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMACounterStruct" field="u64RequestorBadResponse"></counter>
					<counter name="Requestor CQE Flushed" uri="Cavium.qend.RDMACounters.Requestor_CQE_Flushed_Errors" description="The number of times requestor CQEs flushed with error." id="4" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMACounterStruct" field="u64RequestorCQEFlushedErrors"></counter>
					<counter name="Requestor Local Length" uri="Cavium.qend.RDMACounters.Requestor_Local_Length_Errors" description="Work Request posted to the local 'Send Queue' when the sum of the 'Data Segment' lengths exceeds the message length for the channel adapter port." id="5" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMACounterStruct" field="u64RequestorLocalLengthErrors"></counter>
					<counter name="Requestor Local Protection" uri="Cavium.qend.RDMACounters.Requestor_Local_Protection_Errors" description="The locally posted Work Request’s 'Data Segment' does not reference a Memory Region that is valid for the requested operation." id="6" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMACounterStruct" field="u64RequestorLocalProtectionErrors"></counter>
					<counter name="Requestor Remote Access" uri="Cavium.qend.RDMACounters.Requestor_Remote_Access_Errors" description="Remote side received RDMA request with violating R_Key/PD is received." id="7" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMACounterStruct" field="u64RequestorRemoteAccessErrors"></counter>
					<counter name="Requestor Remote Invalid Request" uri="Cavium.qend.RDMACounters.Requestor_Remote_Invalid_Request_Errors" description="The responder detected an invalid message on the channel. Possible causes include the operation is not supported by this receive queue, insufficient buffering to receive a new RDMA or Atomic Operation request, or the length specified in an RDMA request is greater than 231 bytes." id="8" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMACounterStruct" field="u64RequestorRemoteInvalidRequestErrors"></counter>
					<counter name="Requestor Remote Operation" uri="Cavium.qend.RDMACounters.Requestor_Remote_Operation_Errors" description="The operation could not be completed successfully by the responder. Possible causes include a responder QP related error that prevented the responder from completing the request or a malformed WQE on the Receive Queue." id="9" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMACounterStruct" field="u64RequestorRemoteOperationErrors"></counter>
					<counter name="Requestor Retry Exceeded" uri="Cavium.qend.RDMACounters.Requestor_Retry_Exceeded_Errors" description="Transport retries have exceeded maximum limit." id="10" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMACounterStruct" field="u64RequestorRetryExceededErrors"></counter>
					<counter name="Requestor RNR NAK Retry Exceeded" uri="Cavium.qend.RDMACounters.Requestor_RNR_NAK_Retry_Exceeded" description="Retry due to RNR NAK received have been tried max number of times without success." id="11" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMACounterStruct" field="u64RequestorRNRNAKRetryExceeded"></counter>
					<counter name="Responder CQE Flushed" uri="Cavium.qend.RDMACounters.Responder_CQE_Flushed_Errors" description="Responder CQEs flushed with error." id="12" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMACounterStruct" field="u64ResponderCQEFlushedErrors"></counter>
					<counter name="Responder Local Length" uri="Cavium.qend.RDMACounters.Responder_Local_Length_Errors" description="Inbound 'Send' request message exceeded the responder’s available buffer space." id="13" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMACounterStruct" field="u64ResponderLocalLengthErrors"></counter>
					<counter name="Responder Local Protection" uri="Cavium.qend.RDMACounters.Responder_Local_Protection_Errors" description="The locally posted Work Request’s 'Data Segment' does not reference a Memory Region that is valid for the requested operation." id="14" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMACounterStruct" field="u64ResponderLocalProtectionErrors"></counter>
					<counter name="Responder Local QP Operation" uri="Cavium.qend.RDMACounters.Responder_Local_QP_Operation_Errors" description="An internal QP consistency error was detected while processing this Work Request." id="15" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMACounterStruct" field="u64ResponderLocalQPOperationErrors"></counter>
					<counter name="Responder Remote Invalid Request" uri="Cavium.qend.RDMACounters.Responder_Remote_Invalid_Request_Errors" description="The responder detected an invalid message on the channel. Possible causes include the operation is not supported by this receive queue, insufficient buffering to receive a new RDMA or Atomic Operation request, or the length specified in an RDMA request is greater than 231 bytes." id="16" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMACounterStruct" field="u64ResponderRemoteInvalidRequestErrors"></counter>
				</counterSet>
				<counterSet name="Cavium FastLinQ RDMA Connection Counters" symbol="RDMACon" guid="{4e41fac1-19b5-40fb-b7d1-0c609858cb80}" uri="Cavium.qend.RDMACon" description="This set contains RDMA connection error numbers." instances="multipleAggregate">
					<structs>
						<struct name="RDMAConStruct" type="pcw_rdma_con_t"></struct>
					</structs>
					<counter name="SRQ Limit Reached" uri="Cavium.qend.RDMACon.srq_limit_reached" description="This counter is number of times low watermark warning for WQEs in an SRQ occurred." id="1" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAConStruct" field="u64SrqLimitReached"></counter>
					<counter name="Local Invalid Req Error" uri="Cavium.qend.RDMACon.local_invalid_req_err" description="Responder has received an invalid request that cannot be associated with an RQ operation." id="2" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAConStruct" field="u64LocalInvalidReqErr"></counter>
					<counter name="Local Access Error" uri="Cavium.qend.RDMACon.local_access_err" description="Responder is attempting to access memory without sufficient privileges, or target memory region does not exist." id="3" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAConStruct" field="u64LocalAccessErr"></counter>
					<counter name="QP Catastrophic Error" uri="Cavium.qend.RDMACon.qp_catastrophic_err" description="The number of times local catastrophic error happened." id="4" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAConStruct" field="u64QpCatastrophicErr"></counter>
					<counter name="SRQ Empty" uri="Cavium.qend.RDMACon.srq_empty" description="The number of times attempt made to consume a WQE from SRQ when it was empty." id="5" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAConStruct" field="u64SrqEmpty"></counter>
					<counter name="IWARP Irq Full" uri="Cavium.qend.RDMACon.iwarp_irq_full" description="This is number of RDMA READ request when IRQ is full." id="6" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAConStruct" field="u64IwarpIrqFull"></counter>
					<counter name="IWARP Rq Empty" uri="Cavium.qend.RDMACon.iwarp_rq_empty" description="This is number of RDMA SEND request when free RQ is not available." id="7" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAConStruct" field="u64IwarpRqEmpty"></counter>
					<counter name="IWARP LLP Timeout" uri="Cavium.qend.RDMACon.iwarp_llp_timeout" description="This is number of times retransmitted a packet more than a pre-defined threshold and didn’t get ACK." id="8" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAConStruct" field="u64IwarpLlpTimeout"></counter>
					<counter name="Remote Protect Error" uri="Cavium.qend.RDMACon.remote_protect_err" description="This is counter for Remote request failure on MR’s validations." id="9" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAConStruct" field="u64RemoteProtectErr"></counter>
					<counter name="Remote Operation Error" uri="Cavium.qend.RDMACon.remote_oper_err" description="The number of times operation/protocol error caused by Remote Consumer." id="10" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAConStruct" field="u64RemoteOperErr"></counter>
					<counter name="IWARP Terminate Received" uri="Cavium.qend.RDMACon.iwarp_terminate_rcvd" description="This is number of times Remote terminate is received." id="11" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAConStruct" field="u64IwarpTerminateRcvd"></counter>
					<counter name="Remote Graceful Disc" uri="Cavium.qend.RDMACon.remote_graceful_disc" description="This counter is for number of times TCP FIN is received from remote." id="12" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAConStruct" field="u64RemoteGracefulDisc"></counter>
					<counter name="Remote Abortive Disc" uri="Cavium.qend.RDMACon.remote_abortive_disc" description="This counter is for number of times TCP RST is received from remote." id="13" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAConStruct" field="u64RemoteAbortiveDisc"></counter>
					<counter name="Local Graceful Disc" uri="Cavium.qend.RDMACon.local_graceful_disc" description="This counter is for number of times RDMA consumer initiated graceful disconnect for an eastablished connection." id="14" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAConStruct" field="u64LocalGracefulDisc"></counter>
					<counter name="Local Abortive Disc" uri="Cavium.qend.RDMACon.local_abortive_disc" description="This counter is for number of times RDMA consumer initiated abortive disconnect for an eastablished connection." id="15" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAConStruct" field="u64LocalAbortiveDisc"></counter>
				</counterSet>
				<counterSet name="Cavium FastLinQ RDMA Misc Counters" symbol="RDMAMisc" guid="{7e36285a-ce36-4370-a4d3-5e7c4bdf95b1}" uri="Cavium.qend.RDMAMisc" description="This set contains RDMA miscellaneous numbers." instances="multipleAggregate">
					<structs>
						<struct name="RDMAMiscStruct" type="pcw_rdma_misc_t"></struct>
					</structs>
					<counter name="IWARP Tx Fast Xmit Cnt" uri="Cavium.qend.RDMAMisc.iwarp_tx_fast_xmit_cnt" description="This counter is number of times TCP fast retransmit event occurred." id="1" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAMiscStruct" field="u64IwarpTxFastRxmitCnt"></counter>
					<counter name="IWARP Tx Slow Start Cnt" uri="Cavium.qend.RDMAMisc.iwarp_tx_slow_start_cnt" description="This counter is number of times TCP slow start event occurred." id="2" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAMiscStruct" field="u64IwarpTxSlowStartCnt"></counter>
					<counter name="IWARP Unalign Rx Comp" uri="Cavium.qend.RDMAMisc.iwarp_unalign_rx_comp" description="This counter is number of times MPA unaligned packet is received." id="3" type="perf_counter_large_rawcount" detailLevel="standard" aggregate="sum" struct="RDMAMiscStruct" field="u64IwarpUnalignRxComp"></counter>
				</counterSet>
			</provider>
		</counters>
	</instrumentation>
</instrumentationManifest>
